<?php
/*
Plugin Name: Download Counter
Plugin URI: http://colorsin.com/index.php/2013/03/03/download-counter-bbcode-plugin-for-flatpress/
Description: Adds a download counter bbcode with URL link
Author: Igor Kromin
Version: 1.3
Author URI: http://www.colorsin.com/
*/

require_once '../../../defaults.php';
require_once '../../../fp-includes/core/core.fileio.php';

$downloadFile = urldecode($_GET["x"]);

// make sure the files outside of the download directory are not accessed
if (startsWith($downloadFile, '..') || startsWith($downloadFile, '/') || substr_count($downloadFile, '..') > 0) {
    error_403($downloadFile);
    die;
}

// files are assumed to be in fp-content/attachs directory
$download = '../../../'. ATTACHS_DIR . $downloadFile;

if (file_exists($download)) {    
    
    // if the file cannot be read show 403 error
    if (!is_readable($download)) {
        error_403($downloadFile);
        die;
    }
    
    $f = $download . '.dlctr'; // counter file is in the same location as the download file

    // read the contents of the counter file
    $v = io_load_file($f);
    if ($v === false) {
        $v = 0;
    }
    
    $v++; // increment download counter
    
    // update the counter and write to file
    // io_write_file was not working for some reason, so using this code now
    $file = @fopen($f, "w");
    if ($file) {
            if (flock($file, LOCK_EX))
            {
                fwrite($file, $v);
                flock($file, LOCK_UN);
                fclose($file);
                @chmod($filename, FILE_PERMISSIONS);
            }
    }

    // set some response headers to indicate that a file is being sent
    header("Content-type: application/force-download");
    header('Content-disposition: attachment; filename=' . basename($downloadFile));
    header("Content-Transfer-Encoding: Binary");
    header("Content-length: " . filesize($download));
    
    readfile($download); // send file to browser
}
else {
   error_404($downloadFile);
   die;
}

function startsWith($haystack, $needle)
{
    return !strncmp($haystack, $needle, strlen($needle));
}

function error_403($downloadFile) {
    header('HTTP/1.0 403 Forbidden');
    header('Content-type: text/html; charset=utf-8');
    echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
    echo '<html>';
    echo '<head><title>Error 403 (Forbidden)</title></head>';
    echo '<body>';
    echo '<h1>403 Error - Forbidden</h1>';
    echo '<p><strong>The file that you have requested cannot be sent.<br>';
    echo 'File: <font color="Red">' . $downloadFile . "</font>";
    echo '</strong></p>';
    echo '<p><small><font color="Grey">Generated by <a href="http://colorsin.com/index.php/2013/03/03/download-counter-bbcode-plugin-for-flatpress/">Download Counter plugin</a> for FlatPress.</font></small></p>';
    echo '</body>';
    echo '</html>';
}

function error_404($downloadFile) {
    header('HTTP/1.0 404 Not Found');
    header('Content-type: text/html; charset=utf-8');
    echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
    echo '<html>';
    echo '<head><title>Error 404 (Not Found)</title></head>';
    echo '<body>';
    echo '<h1>404 Error - Not Found</h1>';
    echo '<p><strong>The file that you have requested could not be found.<br>';
    echo 'File: <font color="Red">' . $downloadFile . "</font>";
    echo '</strong></p>';
    echo '<p><small><font color="Grey">Generated by <a href="http://colorsin.com/index.php/2013/03/03/download-counter-bbcode-plugin-for-flatpress/">Download Counter plugin</a> for FlatPress.</font></small></p>';
    echo '</body>';
    echo '</html>';
}

?>